# JwtAuthenticable

Researchable's JWT Authenticable gem. This gem provides a standard way of authenticating users using JWT tokens.

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'researchable_jwt-authenticable'
```

And then execute:

    $ bundle install

Or install it yourself as:

    $ gem researchable_jwt-authenticable

## Usage

Simply add the following to your `ApplicationController`:

```ruby
class ApplicationController < ActionController::API
  include JwtAuthenticable::Auth

  before_action :authenticate_user!
  before_action :set_profile!
  
  attr_accessor :current_profile
  
  # rest of your controller
  
  private

  # @note authorization_token! will raise an error if the token is invalid, but this is called after
  #   authenticate_user! which will raise the same error. Therefore we don't need to rescue the error here.
  def set_profile!
    uuid = authorization_token!['sub']
    @current_profile = Profile.find_by uuid: uuid
    # If current_profile is nil, it is the first time the user is talking to base-backend. If the token is valid we
    # can simply create a new profile.
    @current_profile ||= Profile.create uuid: uuid
  end
end
```
## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake spec` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and the created tag, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/frbl/jwt_authenticable. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [code of conduct](https://github.com/frbl/jwt_authenticable/blob/master/CODE_OF_CONDUCT.md).

## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).

## Code of Conduct

Everyone interacting in the JwtAuthenticable project's codebases, issue trackers, chat rooms and mailing lists is expected to follow the [code of conduct](https://github.com/frbl/jwt_authenticable/blob/master/CODE_OF_CONDUCT.md).
